routes/web.php
<?php

use App\Http\Controllers\HomeController;
use App\Http\Controllers\ProductoController;
use App\Http\Controllers\ProductotiendaController;
use App\Http\Controllers\TiendaController;
use Illuminate\Support\Facades\Route;

// con la uri '/' cargar la accion index del controlador home

// Route::get(
//     '/',  // URI
//     [
//         HomeController::class, // Controlador
//         'index', // accion
//     ]
// )->name('home');

Route::controller(HomeController::class)->group(function () {
    Route::get(
        '/',  // uri
        'index' // accion
    )->name('home');
});

Route::resource('producto', ProductoController::class);
Route::resource('tienda', TiendaController::class);
Route::resource('productotienda', ProductotiendaController::class);

// Route::controller(ProductoController::class)->group(function () {
//     Route::get('/producto', 'index')->name('producto.index');
//     Route::get('/producto/create', 'create')->name('producto.create');
//     Route::post('/producto', 'store')->name('producto.store');
//     Route::get('/producto/edit/{id}', 'edit')->name('producto.edit');
//     Route::get('/producto/{id}', 'show')->name('producto.show');
//     Route::put('/producto/{producto}', 'update')->name('producto.update');
//     Route::delete('/producto/{producto}', 'destroy')->name('producto.destroy');
// });

app/Models/Tienda.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Support\Facades\Schema;

class Tienda extends Model
{
    use HasFactory;

    // nombre de la tabla
    protected $table = 'tiendas';

    // campos asignacion masiva
    protected $fillable = [
        'nombre',
        'ubicacion'
    ];

    public static $labels = [
        'id' => 'Id de la tienda',
        'nombre' => 'Nombre de la tienda',
        'ubicacion' => 'Ubicacion de la tienda',
    ];

    public function productotiendas(): HasMany
    {
        return $this->hasMany(Productotienda::class);
    }

    public function getAttributeLabel($attribute)
    {
        return self::$labels[$attribute] ?? $attribute;
    }
    public function getFields()
    {
        return Schema::getColumnListing($this->table);
    }
}

app/Http/Controllers/TiendaController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\TiendaRequest;
use App\Models\Tienda;
use Illuminate\Http\Request;

class TiendaController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {

        $tiendas = Tienda::paginate(9);

        // los mando a la vista
        return view(
            'tienda.index',
            compact('tiendas')
        );
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        return view('tienda.create');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(TiendaRequest $request)
    {

        $tienda = Tienda::create($request->all());

        return redirect()
            ->route('tienda.show', $tienda)
            ->with('mensaje', 'Tienda creada');
    }

    /**
     * Display the specified resource.
     */
    public function show(Tienda $tienda)
    {
        return view(
            'tienda.show',
            compact('tienda')
        );
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Tienda $tienda)
    {
        return view(
            'tienda.edit',
            compact('tienda')
        );
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(TiendaRequest $request, Tienda $tienda)
    {

        // actualizar el registro
        $tienda->update($request->all());

        return redirect()
            ->route('tienda.show', $tienda)
            ->with('mensaje', 'Registro actualizado');
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Tienda $tienda)
    {
        // eliminamos el registro
        $tienda->delete();

        // redireccionamos
        return redirect()
            ->route('tienda.index')
            ->with('mensaje', 'Registro eliminado');
    }
}

resources/views/tienda/create.blade.php
@extends('layouts.main')

@section('titulo', 'Crear Tienda')

@section('cabecera')
    <section class="pt-5 container">
        <div class="row py-lg-5">
            <h1 class="display-4 fw-bold lh-1 mb-3">Insertar Tienda</h1>
            <p class="col-lg-10 fs-4">
                Insertando una nueva tienda
            </p>
        </div>
    </section>
@endsection

@section('contenido')
    <x-formularios.formulario :errors="$errors" method="POST" route="{{ route('tienda.store') }}">
        <x-formularios.input label="Nombre" name="nombre" :value="old('nombre')" />
        <x-formularios.input label="Ubicacion" name="ubicacion" :value="old('ubicacion')" />
    </x-formularios.formulario>
@endsection

resources/views/tienda/edit.blade.php
@extends('layouts.main')

@section('titulo', 'Editar Tienda')

@section('cabecera')
    <section class="pt-5 container">
        <div class="row py-lg-5">
            <h1 class="display-4 fw-bold lh-1 mb-3">Editar Tienda</h1>
            <p class="col-lg-10 fs-4">
                Editando tienda
            </p>
        </div>
    </section>
@endsection

@section('contenido')
    <x-formularios.formulario :modelo="$tienda" :errors="$errors" method="PUT"
        route="{{ route('tienda.update', $tienda) }}">
        <x-formularios.input label="Nombre" name="nombre" :value="old('nombre', $tienda->nombre)" />
        <x-formularios.input label="Ubicacion" name="ubicacion" :value="old('precio', $tienda->ubicacion)" />
    </x-formularios.formulario>
@endsection

resources/views/tienda/index.blade.php
@extends('layouts.main')

@section('titulo', 'Listado de Tiendas')

@section('cabecera')
    <x-cabecera subtitulo="Listado de Tiendas">
        <i class="fa-solid fa-cart-shopping"></i> Listado de Tiendas
    </x-cabecera>
@endsection

@section('contenido')
    @if (session('mensaje'))
        <div class="row m-3">
            <div class="alert alert-info">
                {{ session('mensaje') }}
            </div>
        </div>
    @endif
    <x-listado :registros="$tiendas" modelo="tienda" :campos="['id', 'nombre', 'ubicacion']" />
@endsection

resources/views/tienda/show.blade.php
@extends('layouts.main')

@section('titulo', 'Mostrar')

@section('cabecera')
    <section class="pt-5 container">
        <div class="row py-lg-5">
            <h1 class="display-4 fw-bold lh-1 mb-3">Ver Tienda</h1>
            <p class="col-lg-10 fs-4">
                Estos son los datos de la tienda creada
            </p>
        </div>
    </section>
@endsection

@section('contenido')
    @if (session('mensaje'))
        <div class="row m-2">
            <div class="alert alert-info">
                {{ session('mensaje') }}
            </div>
        </div>
    @endif
    <div class="row mt-3">
        <div class="col">
            <div class="card shadow-xl">
                <div class="card-body">
                    <h5 class="card-title">
                        {{ $tienda->id }}
                    </h5>
                    <p class="card-text">
                        Nombre: {{ $tienda->nombre }}
                    </p>
                    <p class="card-text">
                        Ubicacion: {{ $tienda->ubicacion }}
                    </p>

                    <div class="card-footer">
                        <div class="vertical-align-bottom d-flex justify-content-between align-items-center">
                            <a href="{{ route('tienda.edit', $tienda->id) }}" class="btn btn-primary">Editar</a>
                            <form action="{{ route('tienda.destroy', $tienda) }}" method="post">
                                @csrf
                                @method('DELETE')
                                <button type="submit" class="btn btn-danger">Eliminar</button>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection